// *********** util.cpp ***********
// implementations of class convert::
//
#include "util.h"

using namespace std;

convert::convert()
{
    filename=(char*)malloc(internal_const::max_filename_length);
    infilename=(char*)malloc(internal_const::max_filename_length);

    *filename=0;
    *infilename=0;
#ifdef STDOUT
    cout << "The Bat v2 Address Book Reader&Converter v0.1a" << endl;
    cout << "(c) 2005 by Ighor Poteryakhin, ighor@ighor.ru" << endl;
#endif
#ifdef DEBUG
#ifdef STDOUT
    cout << "Compiled in DEBUG mode..." << endl;
#endif
#endif
}

convert::~convert()
{
    free (filename);
    free (infilename);
#ifdef STDOUT
    cout << endl << "Will see you again..." << endl;
#endif
}

int convert::init(int argc, char *argv[]) // initializes with given filename
{
    if(argc<2||argc>3)
    {
	ERROR(1,"\
	Usage:\n\
	./convert <file> [from_txt_file]\n\n\
	<file>		- The Bat  .abd address book file\n\
	[from_txt_file] - Text file with source data (names, emails, etc.), see example file\n\
	if [from_txt_file] isn't specified, program simply reads content of .abd file to stdout\n\
	WARNING: if second parametr is specified, <file> will be overwritten!\n\
	NOTE: Groups are not supported while writing...\n\
	");
    }
    if(argc==3)
    {
	strcpy(infilename,argv[2]);
#ifdef STDOUT
	cout << "Using input file " << infilename << "..." << endl;
#endif
	action=true;
    }
    else
	action=false;
    
    strcpy(filename,argv[1]);
#ifdef STDOUT
    cout << "Using .abd file " << filename << "..." << endl;
#endif    

    return 0;
}

bool convert::iswrite()
{
    return action;
}

void convert::clearitem(void)
{
    attr.clear();
}

void convert::print(string x)
{
#ifdef STDOUT
    cout<<x<<endl;
#endif
}

void convert::printitem(void)
{
    for_each(attr.begin(),attr.end(),this->print);
}

void convert::loaditem(char* from, int size)
{
    int i, j, k;
    char t[1024];
    string s;
    i = 0;
    do
    {
	move(&from[i], &k, sizeof(int));
	if(k!=thebat_const::aatEnd)
	{
    	    move(&from[i+sizeof(int)], &j, sizeof(int));
    	    if(k==thebat_const::aatCert||k==thebat_const::aatEmails||k==thebat_const::aatPhoto||(k>=thebat_const::aatMinAttr && k<=thebat_const::aatMaxAttr))
	    {
        	move(&from[i+2*sizeof(int)],t,j);
		t[j]='\0';
		s=t;
#ifdef DEBUG
		itoa(k,t);
		s+=" #";
		s+=t;
#endif
        	attr.push_back(s);
	    }
    	    i+=2*sizeof(int)+j;
	}
    } while ((k != thebat_const::aatEnd) && (i <= size));
}

int convert::getint(char *b, int *x, int sz)
{
    int i;
    if(sz<*x+sizeof(int))
	return -1;
    else
    {
	move(b+*x, &i, sizeof(int));
        *x+=sizeof(int);
    }
    return i;
}

char* convert::getstr(char *b, int *x, int *w, int sz)
{
#ifdef DEBUG
#ifdef STDOUT
    cout<<"DEBUG: starting convert::getstr() with sz="<<sz<<", *x="<<*x<<",*w="<<*w<<", bytes are:"<<endl;
    for(int i=0;i<sz;i++)
	cout<<(short)b[i]<<"|";
    cout<<endl;
    for(int i=*x;i<*x+*w;i++)
	cout<<(short)b[i]<<"|";
    cout<<endl;
#endif
#endif
    char res[1024];

    res[0]='\0';
    if(*x+*w>sz)
	*w=sz-*x;
    if(*w>0)
    {
	move(b+*x,res,*w);
	res[*w]='\0';
    }
    *x+=*w;
#ifdef DEBUG
#ifdef STDOUT
    cout<<"DEBUG: convert::getstr returned:"<<endl;
    int i=0;
    while(i<1024)
	cout<<(short)res[i++]<<"|";
    cout<<endl;
#endif
#endif
    return res;
}

void convert::loadcontrol(char* b, int sz)
{
#ifdef DEBUG
#ifdef STDOUT
    cout<<"DEBUG: starting loadcontrol with "<<sz<<" bytes of data"<<endl;
#endif
#endif
    string s;
    char *sp;

    char t[1024];
    t[0]='\0';
    int k;
    
    int p,x,w;
    x=0;
    while(x<sz)
    {
	p=getint(b,&x,sz);
	w=getint(b,&x,sz);
	if((p<0)||(w<0))
	    break;
	switch(p)
	{
	    using namespace thebat_const;
    	    case CTL_ID_Name:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_Name :"+s; attr.push_back(s);
		break;
    	    case CTL_ID_Memo:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_Memo :"+s; attr.push_back(s);
		break;
	    case CTL_ID_LDAP:
		k=getint(b,&x,sz);
		s="ID_LDAP :";
		s+= k!=0?"Yes":"No"; attr.push_back(s);
		break;
	    case CTL_ID_LDAPSRV:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_LDAPSRV :"+s; attr.push_back(s);
		break;
	    case CTL_ID_LDAPSec:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_LDAPSec :"+s; attr.push_back(s);
		break;
	    case CTL_ID_LDAPUser:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_LDAPUser :"+s; attr.push_back(s);
		break;
	    case CTL_ID_LDAPPwd:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_LDAPPwd :"+s; attr.push_back(s);
		break;
    	    case CTL_ID_LDAPSSL:
		k=getint(b,&x,sz);
		s="ID_LDAPSSL :";
		s+= k!=0?"Yes":"No"; attr.push_back(s);
		break;
    	    case CTL_ID_LDAPPort:
		k=getint(b,&x,sz);
		s="ID_LDAPPort :";
		itoa(k,t);
		s+=t; attr.push_back(s);
		break;
    	    case CTL_ID_LDAPBase:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_LDAPBase :"+s; attr.push_back(s);
		break;
    	    case CTL_ID_LDAPSize:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_LDAPSize :"+s; attr.push_back(s);
		break;
    	    case CTL_ID_LDAPTime:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_LDAPTime :"+s; attr.push_back(s);
		break;
    	    case CTL_ID_LDAPUnicode:
		k=getint(b,&x,sz);
		s="ID_LDAPUnicode :";
		s+= k!=0?"Yes":"No"; attr.push_back(s);
		break;
    	    case CTL_ID_CA:
		k=getint(b,&x,sz);
		s="ID_LDAPCA :";
		itoa(k,t);
		s+=t; attr.push_back(s);
		break;
    	    case CTL_ID_UID:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_UID :"+s; attr.push_back(s);
		break;
    	    case CTL_ID_CA_REV:
		sp=getstr(b,&x,&w,sz);
		s=sp; s="ID_CA_REV :"+s; attr.push_back(s);
		break;

	    using namespace std;

    	    default:
		x+=w;
	}
    }
    
}

void convert::loadgroup(char* b, int sz)
{
#ifdef DEBUG
#ifdef STDOUT
    cout<<"DEBUG: starting convert::loadgroup() with "<<sz<<" bytes of data"<<endl;
#endif
#endif
    string s;
    char t[1024];
    int i,n,k,j,l;
    i=0;
    do
    {
	move(b+i,&k,sizeof(int));
	i+=sizeof(int);
	if(k>=0 && k<=thebat_const::ggaMaxAttr)
	{
	    move(b+i, &n, sizeof(int));
    	    i+=sizeof(int);
	    move(b+i,t,n);
	    t[n]='\0';
    	    s=t;
#ifdef DEBUG
	    itoa(k,t);
	    s+=" #";
	    s+=t;
#endif
    	    attr.push_back(s);

            i+=n;
	}
	else if(k==thebat_const::ggaItems)
	{
            move(b+i, &n, sizeof(int));
            i+=sizeof(int);
            for(j=0;j<=n;j++)
	    {
    		move(b+i, &l, sizeof(int));
		s="Item :";
		itoa(l,t);
		s+=" #";
		s+=t;
        	attr.push_back(s);
                i+=sizeof(int);
                if(i>=sz)
		    break;
	    }
	}
	else if(k==thebat_const::ggaEnd)
	    break;
    } while(k!=thebat_const::ggaEnd && i<sz );
}

int convert::readfrom()
{
    int handle,data;
    struct thebat_struct::RAddrHeader raddrheader;
    struct thebat_struct::RAddrSector raddrsector;
    struct thebat_struct::RAddrDataHeader raddrdataheader;
    crc calculator;
    unsigned long actual_crc32, read_crc32;
    time_t t;
    
    if(*filename==0)
	ERROR(1,"Internal error: No filename defined!");
    if ((handle = open(filename, O_RDONLY)) == -1)
	ERROR(1,"Error opening file!");
    if ((data = open(filename, O_RDONLY)) == -1)
	ERROR(1,"Error opening file!");
#ifdef STDOUT
    cout << "File " << filename << " opened sucessfully, reading..." << endl;
#endif
    if(read(handle,&raddrheader,sizeof raddrheader)!=sizeof raddrheader)
	ERROR(1,"Error reading file header!");
#ifdef STDOUT
    cout<<"Header ***************"<<endl;
    cout<<"Sign :"<<raddrheader.Sign;
#endif
    if(raddrheader.Sign==thebat_const::cAddrBaseSign)
#ifdef STDOUT
        cout<<" - CORRECT!" << endl;
#else
	;
#endif
    else
	ERROR(1,"File corrupted, invalid sign!!!");
#ifdef STDOUT
    cout<<"Size :"<<raddrheader.Size<<endl;
    cout<<"NextID :"<<raddrheader.NextID<<endl;
    cout<<"LastChange :"<<raddrheader.LastChange<<endl;
    cout<<"Count :"<<raddrheader.Count<<endl;
    cout<<"Capacity :"<<raddrheader.Capacity<<endl;
    cout<<"**********************" << endl;
    cout<<"Reading directory, "<< raddrheader.Count << " records" << endl ;
#endif
    for (int i=1;i<=raddrheader.Count;i++)
    {
	if(read(handle,&raddrsector,sizeof raddrsector)!=sizeof raddrsector)
	    ERROR(1,"Error reading directory!");
#ifdef STDOUT
        cout<<"************* raddrsector has "<< sizeof raddrsector <<" bytes **************" << endl;
        cout<<"ID :"<<raddrsector.ID<<endl;
        cout<<"ChangeID :"<<raddrsector.ChangeID;
#endif
	if((raddrsector.ChangeID)==0xFFFFFFFF)
	{
#ifdef STDOUT
	    cout << " - RECORD DELETED" << endl;
#else
	    ;
#endif
	}
	else
#ifdef STDOUT
	    cout<<endl;
#else
	    ;
#endif
#ifdef STDOUT
        cout<<"DataPtr :"<<raddrsector.DataPtr<<endl;
        cout<<"XType :"<<(int)raddrsector.XType<<endl;
        cout<<"******** raddrdataheader has "<< sizeof raddrdataheader <<" bytes *********" << endl;
#endif
	if((raddrsector.ChangeID)==0xFFFFFFFF)
	{
#ifdef STDOUT
	    cout << "record marked as deleted, will not process" << endl;
    	    cout<<"***************" << endl;
#endif
	    continue;
	}
	unsigned int offset=raddrheader.Size+raddrsector.DataPtr+raddrheader.Capacity*(sizeof raddrsector);

#ifdef STDOUT
	cout<<"Data header offset is :"<<offset<<endl;
#endif
	if ((lseek(data, offset, SEEK_SET )) == -1L)
	    ERROR(1,"Error seeking data, file is corrupted???");
	if(read(data,&raddrdataheader,sizeof raddrdataheader)!=sizeof raddrdataheader)
	    ERROR(1,"Error reading data, file is corrupted???");
#ifdef STDOUT
	cout<<"Data header is:"<<endl;
	cout<<"Sign :"<<raddrdataheader.Sign;
#endif
	if(raddrdataheader.Sign!=thebat_const::cAddrDataSign)
	    ERROR(1,"File Corrupted!!!");
#ifdef STDOUT
	cout<<" - CORRECT!"<< endl;
	cout<<"ID :"<<raddrdataheader.ID<<endl;
        t=(raddrdataheader.Time);
	cout<<"Time :"<<raddrdataheader.Time<<" - "<<ctime(&t)<<endl;
	cout<<"ChangeID :"<<raddrdataheader.ChangeID<<endl;
	cout<<"Capacity :"<<raddrdataheader.Capacity<<endl;
	cout<<"Size :"<<raddrdataheader.Size<<endl;
	read_crc32=raddrdataheader.CRC;
	cout<<"Read CRC :"<<read_crc32<<endl;
	cout<<"Processing data...";
#endif
	char *p=(char*)malloc(raddrdataheader.Capacity);
	if(read(data,p,raddrdataheader.Capacity)!=raddrdataheader.Capacity)
	    ERROR(1,"Error reading data, file is corrupted???");
	// now p points to data
	actual_crc32=calculator.calccrc32(p,raddrdataheader.Size);
#ifdef STDOUT
	cout<<"Calculated CRC32 is :"<<actual_crc32;
#endif
	if(actual_crc32!=read_crc32)
	    ERROR(1,"Data CRC32 Failed, file is corrupted???")
	else
#ifdef STDOUT
	    cout<<" - CRC32 is OK"<<endl;
#else
	    ;
#endif
	switch((raddrsector.XType))
	{
	    case 0:
#ifdef STDOUT
		cout << "record is address item."<<endl;
#endif
		clearitem();
		loaditem(p,raddrdataheader.Capacity);
		printitem();
		//...
		break;
	    case 1:
#ifdef STDOUT
		cout << "record is address group."<<endl;
#endif
		clearitem();
		loadgroup(p,raddrdataheader.Capacity);
		printitem();
		//...
		break;
	    case 3:
#ifdef STDOUT
		cout << "record is address book properties."<<endl;
#endif
		clearitem();
		loadcontrol(p,raddrdataheader.Capacity);
		printitem();
		//...
		break;
	}
	free(p);
#ifdef STDOUT
        cout<<endl<< "***************"<<endl;
#endif
    }
    close(handle);
    close(data);
    return 0;
}

void convert::cleartxt()
{
    txt.clear();
}

int convert::loadfrom()
{
    string str,name,surname,email;
    Element record;

    if(*infilename==0)
	ERROR(1,"Internal error: No input filename defined!");

    cleartxt();

    ifstream infile (infilename);
    if(!infile.good())
	ERROR(1,"Input file open error!");
    try
    {
	unsigned lineno=0;
	while(getline(infile,str))
	{
	    lineno++;
	    txt.push_back(str); // push whole the string read

	    if(count_sym(str.c_str(),';')!=2)
	    {
//		ERROR(1,"Error in input file!");
		cerr<<"Error in input file, line #"<<lineno<<endl;
		cerr<<"\""<<str<<"\""<<endl;
		continue;
	    }
	    name=surname=str;
	    name.erase(name.find(";",0),name.length()-name.find(";",0));
	    surname.erase(0,surname.find(";",0)+1);
	    email=surname;
	    surname.erase(surname.find(";",0),surname.length()-surname.find(";",0));
	    email.erase(0,email.find(";",0)+1);
	    record.name=name;
	    record.surname=surname;
	    record.email=email;
	    emaildb.push_back(record); // push record {name,surname,email}
	}
    }
    catch(ios_base::failure &var)
    {
	ERROR(1,(char*)var.what());
    }

#ifdef STDOUT
    cout<<"Read of "<<infilename<<" was successfull, "<<txt.size()<<" elements..."<<endl;
#endif
    return 0;
}

#ifdef __BCPLUSPLUS__
int convert::loadfromsql()
{
    Element record;
    string str;

    Form1->Database1->Open();
    Form1->Table1->Open();
    for(int i=0;i<Form1->Table1->RecordCount;i++)
    {
        record.name=Form1->Table1->FieldByName("name")->AsString.c_str();
        record.surname=Form1->Table1->FieldByName("surname")->AsString.c_str();
        record.email=Form1->Table1->FieldByName("email")->AsString.c_str();
        str=record.name+";"+record.surname+";"+record.email;
        txt.push_back(str); // push whole the string read
        emaildb.push_back(record); // push record {name,surname,email}
        Form1->Table1->Next();
    }
    return 0;
}
#endif

bool convert::put(const int handle, const int number)
{
    return write(handle,&number,sizeof (int))==sizeof number?false:true;
}

bool convert::put(const int handle, const char*p)
{
    int len=strlen(p);
    if(put(handle,len))
	return true;
    else
	return write(handle,p,len)==strlen(p)?false:true;
}

int convert::writeto()
{
    struct thebat_struct::RAddrHeader raddrheader;
    struct thebat_struct::RAddrSector raddrsector;
    struct thebat_struct::RAddrDataHeader raddrdataheader;
    vector<unsigned int> offsets;
    vector<unsigned int> crcs;
    unsigned int headerpos, datapos, offset;
    unsigned int changeid;
    time_t timestamp;
    crc calculator;
    int i;
    int handle;
    char *p;
    unsigned int n;

    if(*filename==0)
	ERROR(1,"Internal error: No filename defined!");

#ifndef __BCPLUSPLUS__
    if ((handle = open(filename, O_RDWR|O_TRUNC|O_CREAT,S_IREAD|S_IWRITE)) == -1)
#else
    if ((handle = open(filename, O_RDWR|O_CREAT|O_TRUNC|O_BINARY,S_IREAD|S_IWRITE)) == -1)
#endif
	ERROR(1,"Error opening file for writing!");
#ifndef __BCPLUSPLUS__
    chmod(filename,0640); // rw-r-----
#endif
#ifdef STDOUT
    cout<<"File "<<filename<<" was opened for writing..."<<endl;
#endif
    raddrheader.Sign=thebat_const::cAddrBaseSign;
    raddrheader.Size=sizeof raddrheader;
    raddrheader.NextID=txt.size()-1;
    raddrheader.LastChange=1;
    raddrheader.Count=txt.size()+1;
    raddrheader.Capacity=txt.size()+(256-txt.size());

#ifdef STDOUT
    cout<<"Writing header..."<<endl;
#endif
    if(write(handle,&raddrheader,sizeof raddrheader)!=sizeof raddrheader)
	ERROR(1,"Error writing file header!");

#ifdef STDOUT
    cout<<"Writing directory..."<<endl;
#endif
    changeid=1;
    // directory element for settings, ID=0
    raddrsector.ID=0;
    raddrsector.ChangeID=changeid++;
    raddrsector.DataPtr=0;
    raddrsector.XType=3;
    if(write(handle,&raddrsector,sizeof raddrsector)!=sizeof raddrsector)
	ERROR(1,"Error writing directory!");

    for(i=0;i<raddrheader.Capacity-1;i++) // !!!!!!!!! ID & ChangeID - ???
    {
	/* 0 - item 1 - group 3 - properties */
	if(i<raddrheader.Count)
	{
    	    raddrsector.ID=i;
    	    raddrsector.ChangeID=changeid++;
    	    raddrsector.DataPtr=0;
    	    raddrsector.XType=0;
	}
	else // just empty one...
	{
    	    raddrsector.ID=0;
    	    raddrsector.ChangeID=0;
    	    raddrsector.DataPtr=0;
    	    raddrsector.XType=0;
	}
	if(write(handle,&raddrsector,sizeof raddrsector)!=sizeof raddrsector)
	    ERROR(1,"Error writing directory!");
    }

    changeid=1;
#ifdef STDOUT
    cout<<"Writing settings data header..."<<endl;
#endif
    headerpos=lseek(handle, 0, SEEK_CUR );
    offsets.push_back(headerpos);

    raddrdataheader.Sign=thebat_const::cAddrDataSign;
    raddrdataheader.ID=0;
    raddrdataheader.Time=time(&timestamp);
    raddrdataheader.ChangeID=changeid;
    raddrdataheader.Capacity=0;
    raddrdataheader.Size=0;
    
    if(write(handle,&raddrdataheader,sizeof raddrdataheader)!=sizeof raddrdataheader)
	ERROR(1,"Error writing data header!!!");

    datapos=lseek(handle, 0, SEEK_CUR );

#ifdef STDOUT
    cout<<"Writing settings data..."<<endl;
#endif
    char ID_Name[]="Auto generated TheBat(tm) address book";
    char ID_Memo[]="";
    int ID_LDAP=0;
    char ID_LDAPSRV[]="";
    char ID_LDAPSec[]="";
    char ID_LDAPUser[]="";
    char ID_LDAPPwd[]="";
    char ID_LDAPSSL=0;
    int ID_LDAPPort=389;
    char ID_LDAPSize[]="";
    char ID_LDAPBase[]="";
    char ID_LDAPTime[]="";
    int ID_LDAPUnicode=0;
    int ID_CA=0;
    char ID_UID[]="5af36edb-D2877C6B-B828DC19";
    char ID_CA_REV[]="";
    
    if(put(handle,(int)thebat_const::CTL_ID_Name))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_Name))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_Memo))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_Memo))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAP))
	ERROR(1,"Error writing data!!!");
    if(put(handle,(int)0))
	ERROR(1,"Error writing data!!!");
    if(put(handle,(int)ID_LDAP))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPSRV))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPSRV))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPSec))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPSec))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPUser))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPUser))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPPwd))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPPwd))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPSSL))
	ERROR(1,"Error writing data!!!");
    if(put(handle,(int)0))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPSSL))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPPort))
	ERROR(1,"Error writing data!!!");
    if(put(handle,(int)0))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPPort))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPSize))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPSize))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPBase))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPBase))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPTime))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPTime))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_LDAPUnicode))
	ERROR(1,"Error writing data!!!");
    if(put(handle,(int)0))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_LDAPUnicode))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_CA))
	ERROR(1,"Error writing data!!!");
    if(put(handle,(int)0))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_CA))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_UID))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_UID))
	ERROR(1,"Error writing data!!!");

    if(put(handle,(int)thebat_const::CTL_ID_CA_REV))
	ERROR(1,"Error writing data!!!");
    if(put(handle,ID_CA_REV))
	ERROR(1,"Error writing data!!!");

    offset=lseek(handle,0,SEEK_CUR);
    if ((lseek(handle, datapos, SEEK_SET )) == -1L)
        ERROR(1,"Error seeking data, file is corrupted or internal error???");

    p=(char*)malloc(offset-datapos);
#ifdef DEBUG
#ifdef STDOUT
    cout<<offset-datapos<<"="<<offset<<"-"<<datapos<<endl;
#endif
#endif

    if(read(handle,p,offset-datapos)!=offset-datapos)
	ERROR(1,"Error reading written data???!!!");
        
    if ((lseek(handle, headerpos, SEEK_SET )) == -1L)
        ERROR(1,"Error seeking data, file is corrupted or internal error???");

    if(read(handle,&raddrdataheader,sizeof raddrdataheader)!=sizeof raddrdataheader)
	ERROR(1,"Error reading written data header???!!!");

    raddrdataheader.Capacity=raddrdataheader.Size=offset-datapos;
    raddrdataheader.CRC=calculator.calccrc32(p,raddrdataheader.Size);

    if ((lseek(handle, headerpos, SEEK_SET )) == -1L)
        ERROR(1,"Error seeking data, file is corrupted or internal error???");

    if(write(handle,&raddrdataheader,sizeof raddrdataheader)!=sizeof raddrdataheader)
	ERROR(1,"Error writting data header(2nd pass)???!!!");

    free(p);

#ifdef STDOUT
    cout<<"Writing names&emails..."<<endl;
#endif
    for(i=0;i<emaildb.size();i++)
    {
	string name;
	if ((lseek(handle, 0, SEEK_END )) == -1L)
    	    ERROR(1,"Error end of file, file is corrupted or internal error???");

	headerpos=lseek(handle, 0, SEEK_CUR );
	offsets.push_back(headerpos);

	raddrdataheader.Sign=thebat_const::cAddrDataSign;
	raddrdataheader.ID=i;
	raddrdataheader.Time=time(&timestamp);
	raddrdataheader.ChangeID=(changeid++)+1;
	raddrdataheader.Capacity=0;
	raddrdataheader.Size=0;

	if(write(handle,&raddrdataheader,sizeof raddrdataheader)!=sizeof raddrdataheader)
	    ERROR(1,"Error writing data header!!!");

	datapos=lseek(handle, 0, SEEK_CUR );

	name=emaildb[i].name+" ";
	name+=emaildb[i].surname;
	if(put(handle,(int)thebat_const::aatName))
	    ERROR(1,"Error writing data!!!");
	if(put(handle,name.c_str()))
	    ERROR(1,"Error writing data!!!");

	if(put(handle,(int)thebat_const::aatFirstName))
	    ERROR(1,"Error writing data!!!");
	if(put(handle,emaildb[i].name.c_str()))
	    ERROR(1,"Error writing data!!!");

	if(put(handle,(int)thebat_const::aatLastName))
	    ERROR(1,"Error writing data!!!");
	if(put(handle,emaildb[i].surname.c_str()))
	    ERROR(1,"Error writing data!!!");

	if(put(handle,(int)thebat_const::aatEmails))
	    ERROR(1,"Error writing data!!!");
	if(put(handle,emaildb[i].email.c_str()))
	    ERROR(1,"Error writing data!!!");

	if(put(handle,(int)thebat_const::aatCharset))
	    ERROR(1,"Error writing data!!!");
	if(put(handle,"Windows-1251"))
	    ERROR(1,"Error writing data!!!");

	offset=lseek(handle,0,SEEK_CUR);
	if ((lseek(handle, datapos, SEEK_SET )) == -1L)
    	    ERROR(1,"Error seeking data, file is corrupted or internal error???");

	p=(char*)malloc(offset-datapos);
#ifdef DEBUG
#ifdef STDOUT
	cout<<offset-datapos<<"="<<offset<<"-"<<datapos<<endl;
#endif
#endif

	if(read(handle,p,offset-datapos)!=offset-datapos)
	    ERROR(1,"Error reading written data???!!!");
        
	if ((lseek(handle, headerpos, SEEK_SET )) == -1L)
    	    ERROR(1,"Error seeking data, file is corrupted or internal error???");

	if(read(handle,&raddrdataheader,sizeof raddrdataheader)!=sizeof raddrdataheader)
	    ERROR(1,"Error reading written data header???!!!");

	raddrdataheader.Capacity=raddrdataheader.Size=offset-datapos;
	raddrdataheader.CRC=calculator.calccrc32(p,raddrdataheader.Size);

	if ((lseek(handle, headerpos, SEEK_SET )) == -1L)
    	    ERROR(1,"Error seeking data, file is corrupted or internal error???");

	if(write(handle,&raddrdataheader,sizeof raddrdataheader)!=sizeof raddrdataheader)
	    ERROR(1,"Error writting data header(2nd pass)???!!!");

	free(p);

#ifdef DEBUG
#ifdef STDOUT
	cout<<emaildb[i].name<<";"<<emaildb[i].surname<<";"<<emaildb[i].email<<endl;
#endif
#endif
    }
#ifdef STDOUT
    cout<<"Updating directory..."<<endl;
#endif

    for(i=0;i<offsets.size();i++)
    {
	if ((lseek(handle, (sizeof raddrheader)+(i+1)*(sizeof raddrsector), SEEK_SET )) == -1L)
	    ERROR(1,"Error seeking written data, file is corrupted or internal error???");

	if(read(handle,&raddrsector,sizeof raddrsector)!=sizeof raddrsector)
	    ERROR(1,"Error reading written data sector???!!!");

	raddrsector.DataPtr=offsets[i+1]-raddrheader.Size-raddrheader.Capacity*(sizeof raddrsector);

	if ((lseek(handle, (sizeof raddrheader)+(i+1)*(sizeof raddrsector), SEEK_SET )) == -1L)
	    ERROR(1,"Error seeking written data, file is corrupted or internal error???");

	if(write(handle,&raddrsector,sizeof raddrsector)!=sizeof raddrsector)
	    ERROR(1,"Error writing data sector (2nd pass)???!!!");

    }

#ifdef STDOUT
    cout<<"Success!"<<endl;
#endif
    return 0;
}
